package argonavis.rtf;

import java.io.*;
import org.apache.tools.ant.*;
import junit.framework.*;

public class RtfTaskTest extends TestCase {
    
    private File sourceDir, destDir, foFile, rtfFile;
    private RtfTask task;
    
    public RtfTaskTest(java.lang.String testName) {
        super(testName);
    }
    public static void main(java.lang.String[] args) {
        junit.textui.TestRunner.run(suite());
    }
    public static Test suite() {
        TestSuite suite = new TestSuite(RtfTaskTest.class);
        return suite;
    }
    
    public void setUp() {
        task = new RtfTask();
        
        sourceDir = new File("srcdirTest");
        foFile = new File("srcdirTest/test.fo");
        assertTrue("Required test directory does not exist!", sourceDir.exists());
        assertTrue("Required test file does not exist!", foFile.exists());
        
        destDir = new File("rtfdirTest");
        destDir.mkdir();
        
        rtfFile = new File("rtfdirTest/test.rtf");
    }
    
    public void tearDown() {
        rtfFile.delete();
        destDir.delete();
    }
    
    public void testExecute() throws BuildException {
        task.setDestdir(destDir);
        task.setBasedir(sourceDir);
        task.execute();
        assertTrue(rtfFile.exists());
    }
    
    public void testSetBasedir() throws BuildException {
        task.setBasedir(sourceDir);
        assertEquals(task.getBasedir(), sourceDir);
    }
    
    public void testSetDestdir() throws BuildException {
        task.setDestdir(destDir);
        assertEquals(task.getDestdir(), destDir);
    }
    
    public void testGeneratePDF() throws IOException {
        RtfTask.generateRTF(foFile, rtfFile);
        assertTrue(rtfFile.exists());
	}
    
}
